<?php
/**
	konfigurace texy!
	Tento config je určený pro fora, knihy návštěv a jiné podobné věci
	Je poměrně restriktivní, další věci lze povolit/zakázat editací
	Vlastnosti této konfigurace
     	- html převádí na entity
     	- jsou zakázané linkové definice
     	- jsou zakázané nadpisy
     	- odkazy jsou doplněné o rel="nofollow"

	Chcete-li změnit nastavení, učiňte tak, ale na podrobnosti se ptejte na http://texy.info
**/
TexyConfigurator::safeMode($texy);

//zakázání referencí
$texy->allowed['link/definition'] = false;
$texy->allowed['image/definition'] = false;

//zakázaní nadpisů
$texy->allowed['heading/surrounded'] = false;
$texy->allowed['heading/underlined'] = false;

//zalamování textu v odstavcích po enteru
$texy->mergeLines = false;

//fráze
$texy->allowed['phrase/ins'] = false;			// ++inserted++
$texy->allowed['phrase/del'] = true;			// --deleted--
$texy->allowed['phrase/sup'] = false;			// ^^superscript^^
$texy->allowed['phrase/sub'] = false;			// __subscript__
$texy->allowed['phrase/cite'] = true;			// ~~cite~~
$texy->allowed['deprecated/codeswitch'] = true;	// `=code

//vypnutí/zapnutí html tagů
$texy->allowed['tags'] = false;


//nastavení pro odkazy
//automatické doplňování rel="nofollow" k odkazům
$texy->linkModule->forceNoFollow = true;


/*
	zakáže převádění všech typů adres (email, http, www, "...":, ...) na odkazy
*/
//	TexyConfigurator::disableLinks($texy);

/*
	povolí / zakáže převody jednotlivých druhů odkazů
*/
$texy->allowed['link/link'] = true;
$texy->allowed['link/url'] = true;
$texy->allowed['link/email'] = true;


/*
	includujeme nastavení smajlíků
*/
$emoticons = 'texy';	//nebo 'silk'
include dirname(__FILE__) . '/../../emoticons/' . $emoticons . '/cfg.php';

?>